---
title: Document.querySelector()
slug: Web/API/Document/querySelector
tags:
  - API
  - CSS Selectors
  - DOM
  - DOM Elements
  - Document
  - Method
  - Reference
  - Selector API
  - Selectors
  - querySelector
---
<div>{{ApiRef("DOM")}}</div>

<p>The {{domxref("Document")}} method <code><strong>querySelector()</strong></code> returns the first {{domxref("Element")}} within the document that matches the specified selector, or group of selectors. If no matches are found, <code>null</code> is returned.</p>

<div class="note">
<p><strong>Note</strong>: The matching is done using depth-first pre-order traversal of the document's nodes starting with the first element in the document's markup and iterating through sequential nodes by order of the number of child nodes.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>element</var> = document.querySelector(<var>selectors</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>selectors</var></dt>
 <dd>A {{domxref("DOMString")}} containing one or more selectors to match. This string must be a valid CSS selector string; if it isn't, a <code>SYNTAX_ERR</code> exception is thrown. See <a href="/en-US/docs/Web/API/Document_object_model/Locating_DOM_elements_using_selectors">Locating DOM elements using selectors</a> for more about selectors and how to manage them.</dd>
</dl>

<div class="note">
<p><strong>Note:</strong> Characters that are not part of standard CSS syntax must be escaped using a backslash character. Since JavaScript also uses backslash escaping, be especially careful when writing string literals using these characters. See {{anch("Escaping special characters")}} for more information.</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("HTMLElement")}} object representing the first element in the document that matches the specified set of <a href="/en-US/docs/Web/CSS/CSS_Selectors">CSS selectors</a>, or <code>null</code> is returned if there are no matches.</p>

<p>If you need a list of all elements matching the specified selectors, you should use {{domxref("Document.querySelectorAll", "querySelectorAll()")}} instead.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>SYNTAX_ERR</code></dt>
 <dd>The syntax of the specified <var>selectors</var> is invalid.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>If the specified selector matches an ID that is incorrectly used more than once in the document, the first element with that ID is returned.</p>

<p><a href="/en-US/docs/Web/CSS/Pseudo-elements">CSS pseudo-elements</a> will never return any elements, as specified in the <a href="http://www.w3.org/TR/selectors-api/#grammar">Selectors API</a>.</p>

<h3 id="Escaping_special_characters">Escaping special characters</h3>

<p>To match against an ID or selectors that do not follow standard CSS syntax (by using a colon or space inappropriately, for example), you must escape the character with a backslash ("<code>\</code>"). As the backslash is also an escape character in JavaScript, if you are entering a literal string, you must escape it <em>twice</em> (once for the JavaScript string, and another time for <code>querySelector()</code>):</p>

<pre class="brush: html">&lt;div id="foo\bar"&gt;&lt;/div&gt;
&lt;div id="foo:bar"&gt;&lt;/div&gt;

&lt;script&gt;
  console.log('#foo\bar');               // "#fooar" (\b is the backspace control character)
  document.querySelector('#foo\bar');    // Does not match anything

  console.log('#foo\\bar');              // "#foo\bar"
  console.log('#foo\\\\bar');            // "#foo\\bar"
  document.querySelector('#foo\\\\bar'); // Match the first div

  document.querySelector('#foo:bar');    // Does not match anything
  document.querySelector('#foo\\:bar');  // Match the second div
&lt;/script&gt;</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Finding_the_first_element_matching_a_class">Finding the first element matching a class</h3>

<p>In this example, the first element in the document with the class "<code>myclass</code>" is returned:</p>

<pre class="brush: js">var el = document.querySelector(".myclass");
</pre>

<h3 id="A_more_complex_selector">A more complex selector</h3>

<p>Selectors can also be really powerful, as demonstrated in the following example. Here, the first {{HTMLElement("input")}} element with the name "login" (<code>&lt;input name="login"/&gt;</code>) located inside a {{HTMLElement("div")}} whose class is "user-panel main" (<code>&lt;div class="user-panel main"&gt;</code>) in the document is returned:</p>

<pre class="brush: js">var el = document.querySelector("div.user-panel.main input[name='login']");
</pre>

<h3 id="Negation">Negation</h3>

<p>As all CSS selector strings are valid, you can also negate selectors:</p>

<pre class="brush: js">var el = document.querySelector("div.user-panel:not(.main) input[name='login']");</pre>

<p>This will select an input with a parent div with the <code>user-panel</code> class but not the <code>main</code> class.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-parentnode-queryselector", "document.querySelector()")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.Document.querySelector")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Document_object_model/Locating_DOM_elements_using_selectors">Locating DOM elements using selectors</a></li>
 <li>{{domxref("Element.querySelector()")}}</li>
 <li>{{domxref("Document.querySelectorAll()")}}</li>
 <li>{{domxref("Element.querySelectorAll()")}}</li>
 <li><a href="/en-US/docs/Code_snippets/QuerySelector">Code snippets for querySelector</a></li>
</ul>
